searchNodes=[{"doc":"A context for working with Pointers, a sort of global foreign key scheme.","ref":"Pointers.html","title":"Pointers","type":"module"},{"doc":"Return the provided pointer when it belongs to table queryable by the given table search term.","ref":"Pointers.html#assert_points_to!/2","title":"Pointers.assert_points_to!/2","type":"function"},{"doc":"Returns a Pointer, either the one provided or a synthesised one pointing to the provided schema object. Does not hit the database or cause the pointer to be written to the database whatsoever.","ref":"Pointers.html#cast!/1","title":"Pointers.cast!/1","type":"function"},{"doc":"Given a list of pointers which may or may have their pointed loaded, return a plan for preloading, a map of module name to set of loadable IDs.","ref":"Pointers.html#plan/1","title":"Pointers.plan/1","type":"function"},{"doc":"","ref":"Pointers.Changeset.html","title":"Pointers.Changeset","type":"module"},{"doc":"","ref":"Pointers.Changeset.html#insert_related/5","title":"Pointers.Changeset.insert_related/5","type":"function"},{"doc":"","ref":"Pointers.Changeset.html#relate/4","title":"Pointers.Changeset.relate/4","type":"function"},{"doc":"","ref":"Pointers.Changeset.html#valid?/1","title":"Pointers.Changeset.valid?/1","type":"function"},{"doc":"","ref":"Pointers.Entity.html","title":"Pointers.Entity","type":"module"},{"doc":"Migration helpers for creating tables that participate in the pointers abasction.","ref":"Pointers.Migration.html","title":"Pointers.Migration","type":"module"},{"doc":"Adds a pointer primary key to the table. Not required if you are using create_pointable_table","ref":"Pointers.Migration.html#add_pointer_pk/0","title":"Pointers.Migration.add_pointer_pk/0","type":"function"},{"doc":"","ref":"Pointers.Migration.html#add_pointer_ref_pk/0","title":"Pointers.Migration.add_pointer_ref_pk/0","type":"function"},{"doc":"Creates a pointable table along with its trigger.","ref":"Pointers.Migration.html#create_pointable_table/4","title":"Pointers.Migration.create_pointable_table/4","type":"macro"},{"doc":"Creates a trait table - one with a ULID primary key and no trigger","ref":"Pointers.Migration.html#create_trait_table/3","title":"Pointers.Migration.create_trait_table/3","type":"macro"},{"doc":"Drops a pointable table","ref":"Pointers.Migration.html#drop_pointable_table/2","title":"Pointers.Migration.drop_pointable_table/2","type":"function"},{"doc":"","ref":"Pointers.Migration.html#drop_table/1","title":"Pointers.Migration.drop_table/1","type":"function"},{"doc":"Drops a trait table. Actually just a simple cascading drop","ref":"Pointers.Migration.html#drop_trait_table/1","title":"Pointers.Migration.drop_trait_table/1","type":"function"},{"doc":"When migrating up: initialises the pointers database. When migrating down: deinitialises the pointers database.","ref":"Pointers.Migration.html#init_pointers/0","title":"Pointers.Migration.init_pointers/0","type":"function"},{"doc":"Given :up: initialises the pointers database. Given :down: deinitialises the pointers database.","ref":"Pointers.Migration.html#init_pointers/1","title":"Pointers.Migration.init_pointers/1","type":"function"},{"doc":"See Pointers.ULID.Migration.init_pointers_ulid_extra/0.","ref":"Pointers.Migration.html#init_pointers_ulid_extra/0","title":"Pointers.Migration.init_pointers_ulid_extra/0","type":"function"},{"doc":"A Pointer is a kind of global foreign key that can point to any of the tables participating in the abstraction.","ref":"Pointers.Pointer.html","title":"Pointers.Pointer","type":"module"},{"doc":"","ref":"Pointers.Pointer.html#create/2","title":"Pointers.Pointer.create/2","type":"function"},{"doc":"","ref":"Pointers.Pointer.html#repoint/2","title":"Pointers.Pointer.repoint/2","type":"function"},{"doc":"Some macros to help you define schemas.","ref":"Pointers.Schema.html","title":"Pointers.Schema","type":"module"},{"doc":"Defines a schema that can be pointed to - one keyed by autogenerated ULID that you promise to have run the corresponding migrations for.Takes a ULID in text form which is a sentinel value used to identify the table. It must match the one inserted into Table in the migrations that create this table.","ref":"Pointers.Schema.html#pointable_schema/4","title":"Pointers.Schema.pointable_schema/4","type":"macro"},{"doc":"Define a trait schema - one that keyed by ULID, is not pointable and does not autogenerate IDs. Takes a trait name (atom) which will be used to autogenerate alias names sigh","ref":"Pointers.Schema.html#trait_schema/3","title":"Pointers.Schema.trait_schema/3","type":"macro"},{"doc":"Define a table schema with a ULID as a primary key but that is not participating in the pointers abstraction.","ref":"Pointers.Schema.html#ulid_schema/3","title":"Pointers.Schema.ulid_schema/3","type":"macro"},{"doc":"One Table to rule them all. A record of a table participating in the pointers abstraction - mandatory if participating.","ref":"Pointers.Table.html","title":"Pointers.Table","type":"module"},{"doc":"","ref":"Pointers.Table.html#table_id/0","title":"Pointers.Table.table_id/0","type":"function"},{"doc":"","ref":"Pointers.Table.html#t:t/0","title":"Pointers.Table.t/0","type":"type"},{"doc":"A Global cache of Tables to be queried by their (Pointer) IDs, table names or Ecto Schema module names.Use of the Table Service requires:You have run the migrations shipped with this library.You have started Pointers.Tables before querying.All OTP applications with pointable Ecto Schemata to be added to the schema path.OTP 21.2 or greater, though we recommend using the most recent release available.While this module is a GenServer, it is only responsible for setup of the cache and then exits with :ignore having done so. It is not recommended to restart the service as this will lead to a stop the world garbage collection of all processes and the copying of the entire cache to each process that has queried it since its last local garbage collection.","ref":"Pointers.Tables.html","title":"Pointers.Tables","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Pointers.Tables.html#child_spec/1","title":"Pointers.Tables.child_spec/1","type":"function"},{"doc":"","ref":"Pointers.Tables.html#data/0","title":"Pointers.Tables.data/0","type":"function"},{"doc":"Look up a table id by id, name or schema.","ref":"Pointers.Tables.html#id/1","title":"Pointers.Tables.id/1","type":"function"},{"doc":"Look up a table id by id, name or schema, raise NotFound if not found.","ref":"Pointers.Tables.html#id!/1","title":"Pointers.Tables.id!/1","type":"function"},{"doc":"Look up many ids at once, raise NotFound if any of them are not found","ref":"Pointers.Tables.html#ids!/1","title":"Pointers.Tables.ids!/1","type":"function"},{"doc":"Look up a schema module by id, name or schema","ref":"Pointers.Tables.html#schema/1","title":"Pointers.Tables.schema/1","type":"function"},{"doc":"Look up a schema module by id, name or schema, raise NotFound if not found","ref":"Pointers.Tables.html#schema!/1","title":"Pointers.Tables.schema!/1","type":"function"},{"doc":"Populates the global cache with table data via introspection.","ref":"Pointers.Tables.html#start_link/1","title":"Pointers.Tables.start_link/1","type":"function"},{"doc":"Get a Table identified by name, id or module.","ref":"Pointers.Tables.html#table/1","title":"Pointers.Tables.table/1","type":"function"},{"doc":"Look up a Table by name or id, raise NotFound if not found.","ref":"Pointers.Tables.html#table!/1","title":"Pointers.Tables.table!/1","type":"function"},{"doc":"A query is either a table's (database) name or (Pointer) ID as a binary or the name of its Ecto Schema Module as an atom.","ref":"Pointers.Tables.html#t:query/0","title":"Pointers.Tables.query/0","type":"type"},{"doc":"We could not find the requested object","ref":"Pointers.NotFound.html","title":"Pointers.NotFound","type":"exception"},{"doc":"Creates a new NotFound","ref":"Pointers.NotFound.html#new/0","title":"Pointers.NotFound.new/0","type":"function"},{"doc":"","ref":"Pointers.NotFound.html#t:t/0","title":"Pointers.NotFound.t/0","type":"type"},{"doc":"hexdocspointersEcto's missing universal foreign keyOne foreign key to rule them all and in the darkness, bind them.-- Gandalf, paraphrased.A means of foreign keying many tables in one field. Designed for highly interlinked data in highly dynamic schemata where tracking all the foreign keys is neither desired nor practical.Note: a universal foreign key is actually a hard problem. Many approaches are on offer with a variety of tradeoffs. You should carefully consider a variety of approaches rather than just blindly adopting the one that fitted our project's needs the best!","ref":"readme.html","title":"pointers","type":"extras"},{"doc":"A Table is a record of a table that may be linked to by a pointer. A Pointer is a pointer id and a table id.With these two ingredients, we can construct a means of pointing to any table that has a Table entry.Pointer and Table IDs are both Pointers.ULID, a UUID-like type that combines a millisecond-precision timestamp and some randomness to reduce the likelihood of a clash. It naturally sorts both in binary and text form by time and as far as postgres is concerned, it's a UUID.","ref":"readme.html#background","title":"pointers - Background","type":"extras"},{"doc":"Aside from the hex dependency, you will also need to write a simple migration to set up the database before you can start writing your regular migrations:defmodule MyApp.Repo.Migrations.InitPointers do use Ecto.Migration import Pointers.Migration def up(), do: inits(:up) def down(), do: inits(:down) defp inits(dir) do init_pointers_ulid_extra(dir) # this one is optional but recommended init_pointers(dir) # this one is not optional end end","ref":"readme.html#installation","title":"pointers - Installation","type":"extras"},{"doc":"Pointable tables require a unique sentinel ULID to identify them. These must be 26 characters long and in the alphabet of Crockford's Base32. They should be easy to identify in a printout and might be silly.There is a helper function, synthesise!/1 in Pointers.ULID to assist with this process - give it a 26-character long binary of ascii alphanumerics and it will give you the closest ULID that matches back.Let's look at a simple schema:defmodule MyApp.Greeting do use Pointers.Schema pointable_schema(&quot;myapp_greeting&quot;, &quot;GREET1NGSFR0MD0CEXAMP1E000&quot;) do field :greeting, :string end endWe import Pointers.Schema instead of Ecto.Schema, use pointable_schema in place of schema and provide a sentinel ULID for our table. Otherwise it's just like a regular schema definition.Now let's define the migration for our schema:defmodule MyApp.Repo.Migrations.Greeting do use Ecto.Migration import Pointers.Migration def up() do create_pointable_table(:greeting, &quot;GREET1NGSFR0MD0CEXAMP1E000&quot;) do add :greeting, :text, null: false end end def down() do drop_pointable_table(:greeting, &quot;GREET1NGSFR0MD0CEXAMP1E000&quot;) end endAs you can see, it's pretty similar to defining a regular migration, except you use create_pointable_table and drop_pointable_table. Notice that our sentinel ULID makes an appearance again here. It's very important that these match.","ref":"readme.html#defining-a-pointable-table","title":"pointers - Defining a pointable table","type":"extras"},{"doc":"Ecto does not know anything about our scheme, so unless we specifically want something to reference one of the pointed tables, we typically belongs_to with Pointers.Pointer. The table in which we do this does not itself need to be pointable.defmodule MyApp.Foo do use Ecto.Schema alias Pointers.Pointer # regular ecto table, not pointable! schema &quot;hello&quot; do field :pointer, Pointer # who knows what it points to? end endIf you choose to reference a specific table instead, you must ensure that the referenced record exists in that table in the normal way.","ref":"readme.html#referencing-with-pointers","title":"pointers - Referencing with Pointers","type":"extras"},{"doc":"Unfortunately, reading pointers is a bit more involved than writing them. It is likely that depending on the type being pointed to, you will want to execute different queries.Given a Pointer (such as one preloaded on another table), you can inspect the table it points to and switch query based upon this. Pointers.plan can turn a list of Pointers into a map of schema module name to MapSet of ids so you can extend the strategy for bulk.","ref":"readme.html#dereferencing-with-pointers","title":"pointers - Dereferencing with Pointers","type":"extras"},{"doc":"An alternative idea I've been playing with recently takes inspiration from game design, where ECS (entity component system) libraries are the norm.Objects normally can be thought of as a set of named fields. In an ECS, an entity is just an id and it can have any number of components. A component is the set of named fields traditionally like an object, except we can have multiple of them.ECS systems allow preserving the benefits of static typing while allowing code to only care about the components it cares about. By carving at the component level, we are able to build on some details without being fully coupled to the implementation details.Pointers allow us to point to records in a number of tables in the database. By using ECS component-style tables (not themselves pointable), code which cares about certain components may join to those tables. Thus even though a pointer may point to conceptually many tables, common components may be queried by code without having to encode the knowledge of what the types are in the query. It's a bit like graphql interfaces (&quot;data interfaces&quot;) for the database.When inserting a pointable type, it is up to the user's code to insert the components they care about. When updating one, perhaps the relevant components must be updated. When deleting one, you will have to cascade deletes.","ref":"readme.html#trait-tables","title":"pointers - Trait tables","type":"extras"},{"doc":"Docs!Tests!mix pointers.gen.init task to generate an init migrationmix pointers.gen.migration task to generate a skeleton migrationWhat lurks underneath?pointable_schema(name, id, block):create ecto schema configured with a ULID primary keycreate table_id/0 returning the table's sentinel ULIDinit_pointers(:up):create tables for Table and Pointer.creates/replaces backing pointer trigger function.create backing pointer trigger for Table (NOT idempotent).init_pointers(:down):delete backing pointer trigger for Table (NOT idempotent).delete backing pointer trigger function.delete Table and Pointer tables.create_pointable_table(name, block):create table configured with a ULID primary key.create entry in Table table.create backing pointer trigger for table (NOT idempotent).drop_pointable_table(name):delete backing pointer trigger for table (NOT idempotent).delete entry from Table table.delete table.","ref":"readme.html#todo","title":"pointers - TODO","type":"extras"},{"doc":"All solutions to the universal foreign key problem have tradeofs. Here are what we see as the deficiencies in our approach:It forces a ULID on you. This is great for us, but not everyone. ULID exposes a timestamp with millisecond precision. If the time of creation of a resource is sensitive information for your purposes, ULIDs are not going to be suitable for you.Ecto has no knowledge of the specialty of Pointer, e.g. Repo.preload does not work and you need to specify a join condition to join through a pointer. Use our functions.Following a list of pointers requires a select query per table type that occurs in the input set.Reliance on user attention. You have to follow the instructions correctly to make the system work at all.Nonidempotency of migrations. Part of this is postgres not making it convenient, but we can and should do better.Of these, only the last is likely to change. If you're going to pick this library, do so in the full knowledge of the tradeoffs it makes.Alternatives include (I'm sure you can think of others):Storing the table name alongside every foreign key.Creating a postgres datatype containing the id and table name and using that as a foreign key.Byte/String manipulation tricks.","ref":"readme.html#tradeoffs","title":"pointers - Tradeoffs","type":"extras"},{"doc":"Copyright (c) 2020 pointers ContributorsLicensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License athttp://www.apache.org/licenses/LICENSE-2.0Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#copyright-and-license","title":"pointers - Copyright and License","type":"extras"}]